# Changelog

All notable changes to this project will be documented in this file.

The format is based on Keep a Changelog (<https://keepachangelog.com/en/1.0.0/>). This project adheres to Semantic Versioning (<https://semver.org/spec/v2.0.0.html>).

## [v1.2.1] - 2020-05-16

### Added

- Informative error messages when pnpm is not installed.
- Pessimistic gem dependency version specifications to avoid installation conflicts.
- Full-length gem description.
- Forced shameful hoisting of installed pnpm dependencies via `webpacker:pnpm_install`.
- Practical Pig development dependency for external RuboCop linting.

### Changed

- Commented and adjusted RuboCop formatting rules to clarify design decisions.

### Removed

- Testing configs for bleeding-edge Rails.

## [v1.2.0] - 2020-05-14

### Added

- Compatibility with Rails' Template API via command execution hooks and keyword substitution.
- Support for existing Yarn Rake task dependence through task aliasing and redirection.
- Additional Rake tasks to test injection and interception logic.
- Utility method for concurrent and scoped `chdir` calls.

### Changed

- Gem dependencies to reflect up-to-date versions.
- RuboCop formatting rules to support latest versions of Ruby.
- Test application structure to allow application booting.
- Rake task tests to utilize concurrent `chdir` calls.
- Tests to support Rails <6.x `[bugfix]`.
- Tests to support Ruby 2.4.9 `[bugfix]`.

### Removed

- Webpacker git submodule as method for replacing default Rails' rake tasks.
- Dependence on a specific version of Webpacker.

## [v1.1.0] - 2020-04-19

### Changed

- RuboCop formatting rules to more align with Rails' style guide.
- TypeScript installation tasks based on Webpacker v5.1.0.
- Rake tasks to extend ActiveSupport and utilize concurrent threading.

## [v1.0.0] - 2020-04-17

### Added

- Gem specifications and foundational files, generated by Bundler v2.0.2, for defining a Ruby gem.
- Hook into Rails' engine loader for conditional task loading.
- Tasks replacing Yarn with pnpm for Webpacker v5.0.1, included as a submodule.
- Test suite with dummy application.
